Subject: bug#71430: closed (Re: bug#71430: Persistent Highlighting Issue with query-replace using "act-and-show" Option)

From: [email-masked] (GNU bug Tracking System)
Date: Sat, 08 Jun 2024 10:44:02 +0000

Your bug report

#71430: Persistent Highlighting Issue with query-replace using "act-and-show" Option

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
71430: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=71430
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#71430: Persistent Highlighting Issue with query-replace using "act-and-show" Option
From: Eli Zaretskii <[email-masked]>
To: [email-masked]
Cc: [email-masked]
Date: Sat, 08 Jun 2024 13:41:02 +0300
List-Id: <debbugs-submit.debbugs.gnu.org>

> Date: Sat, 8 Jun 2024 11:05:24 +0200
> From: Gabriele Nicolardi <[email-masked]>
> 
> Il 08/06/24 10:33, Eli Zaretskii ha scritto:
> >> Date: Sat, 8 Jun 2024 09:29:41 +0200
> >> From: Gabriele Nicolardi <[email-masked]>
> >>
> >> I’ve encountered a potential bug in Emacs when using the |query-replace|
> >> (via |perform-replace|) functions. When performing text replacements
> >> across a buffer and choosing to replace but not immediately move the
> >> point (using the |,| |act-and-show| option), the function does replace
> >> the text as expected but fails to update the highlighting to the region
> >> containing the replacement.
> >>
> >> *Steps to Reproduce:*
> >>
> >>   1.
> >>
> >>      Open a buffer with the following content:
> >>
> >>      |String to be replaced. Another string. String to be replaced.
> >>      Another string. End |
> >>
> >>   2.
> >>
> >>      Run the following command:
> >>
> >>      |(query-replace "String to be replaced." "Replacement." nil
> >>      (point-min) (point-max)) |
> >>
> >>   3.
> >>
> >>      When prompted to replace a match, use the |,| (|act-and-show|)
> >>      option to replace the text but pause moving to the next match.
> >>
> >> *Expected Behavior:*
> >> After a replacement is made and before moving to the next match, the
> >> highlighted region of the replaced text should be “updated” to fit the
> >> replaced text.
> >>
> >> *Actual Behavior:*
> >> The highlighting remains on the matched region. This issue can be
> >> visually confirmed in the following animation:
> > You don't say in what version of Emacs you see the problematic
> > behavior.  I can reproduce the behavior you report in Emacs 29, but
> > not in Emacs 30 (on the master branch of the Emacs Git repository).
> > So I think this bug was already solved on the master branch, which
> > will become Emacs 30.
> 
> 
> 
> > > Cc: [email-masked]
> > > Date: Sat, 08 Jun 2024 11:33:55 +0300
> > > From: Eli Zaretskii <[email-masked]>
> > > 
> > > > Date: Sat, 8 Jun 2024 09:29:41 +0200
> > > > From: Gabriele Nicolardi <[email-masked]>
> > > > 
> > > > I’ve encountered a potential bug in Emacs when using the |query-replace| 
> > > > (via |perform-replace|) functions. When performing text replacements 
> > > > across a buffer and choosing to replace but not immediately move the 
> > > > point (using the |,| |act-and-show| option), the function does replace 
> > > > the text as expected but fails to update the highlighting to the region 
> > > > containing the replacement.
> > > > 
> > > > *Steps to Reproduce:*
> > > > 
> > > >  1.
> > > > 
> > > >     Open a buffer with the following content:
> > > > 
> > > >     |String to be replaced. Another string. String to be replaced.
> > > >     Another string. End |
> > > > 
> > > >  2.
> > > > 
> > > >     Run the following command:
> > > > 
> > > >     |(query-replace "String to be replaced." "Replacement." nil
> > > >     (point-min) (point-max)) |
> > > > 
> > > >  3.
> > > > 
> > > >     When prompted to replace a match, use the |,| (|act-and-show|)
> > > >     option to replace the text but pause moving to the next match.
> > > > 
> > > > *Expected Behavior:*
> > > > After a replacement is made and before moving to the next match, the 
> > > > highlighted region of the replaced text should be “updated” to fit the 
> > > > replaced text.
> > > > 
> > > > *Actual Behavior:*
> > > > The highlighting remains on the matched region. This issue can be 
> > > > visually confirmed in the following animation:
> > > 
> > > You don't say in what version of Emacs you see the problematic
> > > behavior.  I can reproduce the behavior you report in Emacs 29, but
> > > not in Emacs 30 (on the master branch of the Emacs Git repository).
> > > So I think this bug was already solved on the master branch, which
> > > will become Emacs 30.
> 
> Oh, sorry! My Emacs version is 29.3.

OK, thanks, so I'm now closing this bug.

Subject: Persistent Highlighting Issue with query-replace using "act-and-show" Option
From: Gabriele Nicolardi <[email-masked]>
To: [email-masked]
Date: Sat, 8 Jun 2024 09:29:41 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

Hi,
I’ve encountered a potential bug in Emacs when using the |query-replace| 
(via |perform-replace|) functions. When performing text replacements 
across a buffer and choosing to replace but not immediately move the 
point (using the |,| |act-and-show| option), the function does replace 
the text as expected but fails to update the highlighting to the region 
containing the replacement.

*Steps to Reproduce:*

 1.

    Open a buffer with the following content:

    |String to be replaced. Another string. String to be replaced.
    Another string. End |

 2.

    Run the following command:

    |(query-replace "String to be replaced." "Replacement." nil
    (point-min) (point-max)) |

 3.

    When prompted to replace a match, use the |,| (|act-and-show|)
    option to replace the text but pause moving to the next match.

*Expected Behavior:*
After a replacement is made and before moving to the next match, the 
highlighted region of the replaced text should be “updated” to fit the 
replaced text.

*Actual Behavior:*
The highlighting remains on the matched region. This issue can be 
visually confirmed in the following animation:
View Animation on Imgur <https://imgur.com/a/BxVwVff>

*Visual Evidence:*

  * Highlight *before* using |act-and-show| (match):

  * Highlight *after* using |act-and-show| while paused (replacement):

As demonstrated, the highlighted region post-replacement does not 
correspond to any current match, which is misleading and might affect 
further editing decisions.

Best regards,

Gabriele Nicolardi

​